Solid JS

repository·main·Indexed 12 days ago

https://github.com/solidjs/solid

A declarative JavaScript library for building user interfaces that avoids the Virtual DOM in favor of fine-grained reactivity. It compiles templates to real DOM nodes and updates them directly. The ecosystem includes babel-preset-solid for JSX transformation, solid-element for Web Components, and solid-ssr for various server-side rendering strategies including streaming, async, and static site generation (SSG). It also provides non-compiled alternatives via solid-js/h (HyperScript) and solid-js/html (tagged template literals).

Tokens
26.3K
Snippets
105
Records
123
Agent score
96%

What's inside Solid

  1. Manage deeply nested reactivity with Solid Store

    main

    Solid Store provides primitives for handling deeply nested reactive structures using Proxies. It allows you to create complex state objects where updates to nested properties trigger fine-grained reactivity.

    Core Primitives

    • createStore: The primary way to create a reactive, nested state object.
    • createMutable: An alternative primitive for creating dynamic nested reactive structures.

    Helper Methods

    To augment the behavior of the store setter, you can use:

    • produce: Allows for localized mutation (writing code that looks like direct mutation) within a setter.
    • reconcile: Used for data diffing to update a store to match a new object while preserving reactivity.

    For detailed API documentation, visit the official SolidJS website.

    import { createStore } from "solid-js/store";
    
    const [store, setStore] = createStore({
      user: {
        firstName: "John",
        lastName: "Smith"
      }
    });
    
    // update store.user.firstName
    setStore("user", "firstName", "Will");
  2. Maintain reactivity in HyperScript

    main

    When using HyperScript instead of JSX, you must manually handle reactivity for expressions, props, and spreads. If you do not wrap these in functions, they will be evaluated once at creation time and will not update when the underlying signals change.

    1. Reactive Expressions

    Wrap expressions in a function to ensure they are tracked as reactive getters.

    // Instead of: h("div", { id: props.id }, props.name)
    // Use:
    h("div", { id: () => props.id }, () => props.name)

    2. Merging Props

    To maintain reactivity when spreading props, use the mergeProps helper from solid-js.

    import { mergeProps } from "solid-js";
    import h from "solid-js/h";
    
    // Instead of: h("div", { class: selectedClass(), ...props })
    // Use:
    h("div", mergeProps({ class: selectedClass }, props));

    3. Component Events and Render Props

    Solid's HyperScript automatically wraps functions passed to component props (that have no arguments) in getters. To prevent unexpected behavior with events or render props (like in <For>), provide an explicit argument to the function.

    // Good: Explicit event argument
    h(Button, { onClick: (e) => console.log("Hi") });
    
    // Bad: No arguments might be wrapped incorrectly
    h(Button, { onClick: () => console.log("Hi") });
    import { mergeProps } from "solid-js";
    import h from "solid-js/h";
    
    // Reactive expression and merged props example
    h("div", mergeProps({ class: selectedClass }, props), () => firstName() + lastName());
  3. Compare Solid SSR rendering strategies

    main

    Solid SSR supports four primary rendering strategies depending on when data is queried and how the HTML is delivered to the client:

    1. Standard SSR (ssr): Data is queried on the client. Elements outside suspense boundaries are rendered on the server; everything depending on data is rendered client-side. Uses renderToString.
    2. Streaming SSR (stream): Data is queried on the server at request time. The page is sent with placeholders that are replaced as the stream loads. Uses renderToStream.
    3. Async SSR (async): Data is queried on the server at request time. All nodes are rendered on the server and hydrated on the client. Data is serialized and sent with the page to avoid loading states. Uses renderToStringAsync.
    4. Static Site Generation (ssg): Data is queried on the server at build-time. This follows the same hydration pattern as async but removes real-time rendering overhead. Uses renderToStringAsync.
  4. Reactive Expressions in `html` Tagged Templates

    main

    Unlike JSX, where expressions are automatically tracked, reactive expressions in html tagged templates must be manually wrapped in functions to maintain reactivity. If you pass a raw value that changes, the template will not update; you must pass a getter function.

    Comparison:

    • JSX: <div id={props.id}>{firstName() + lastName()}</div>
    • html: html<div id=${() => props.id}>${() => firstName() + lastName()}</div>``
    html`<div id=${() => props.id}>${() => firstName() + lastName()}</div>`
  5. How SolidJS works: The Render-Once mental model

    main

    Unlike Virtual DOM frameworks, SolidJS compiles templates to real DOM nodes and updates them using fine-grained reactions.

    Key Concepts:

    • Components run once: A component is just a regular JavaScript function that runs once to set up your view. It does not re-run on every state change.
    • Fine-grained updates: When state changes, only the specific code (the reactive dependency) that depends on that state re-runs. The rest of the component remains untouched.
    • Reactive Primitives: You use primitives like createSignal to declare state. Accessing these signals inside a template or an effect automatically creates a subscription.

    Example: Counter Component

    import { createSignal } from "solid-js";
    import { render } from "solid-js/web";
    
    function Counter() {
      // createSignal returns an accessor (count) and a setter (setCount)
      const [count, setCount] = createSignal(0);
      
      // Derived state is created by wrapping an expression in a function
      const doubleCount = () => count() * 2;
      
      console.log("The body of the function runs once...");
    
      return (
        <button onClick={() => setCount(c => c + 1)}>
          Increment: {doubleCount()}
        </button>
      );
    }
    
    render(Counter, document.getElementById("app")!);

    In this example, clicking the button updates the signal, which triggers only the text node inside the button to update. The Counter function itself does not execute again.

    import { createSignal } from "solid-js";
    import { render } from "solid-js/web";
    
    function Counter() {
      const [count, setCount] = createSignal(0);
      const doubleCount = () => count() * 2;
      
      return (
        <button onClick={() => setCount(c => c + 1)}>
          Increment: {doubleCount()}
        </button>
      );
    }
    
    render(Counter, document.getElementById("app")!);
  6. How Solid Universal works for custom renderers

    main

    Solid Universal provides the tools to create a runtime for custom renderers. This allows Solid to target platforms other than the standard DOM, such as native mobile, desktop, canvas, WebGL, or the terminal.

    Creating a custom renderer involves two main steps:

    1. Custom Compilation: Using babel-preset-solid with the generate: 'universal' option and specifying a custom moduleName to point to your renderer package.
    2. Renderer Implementation: Implementing the required interface via createRenderer from solid-js/universal and exporting the resulting methods as named exports from your package.
  7. Advanced Composition with withSolid and register

    main

    For advanced use cases where you want to mix in custom behaviors or use other Higher-Order Components (HOCs), you can use the withSolid mixin directly with component-register's register and compose utilities.

    register upgrades a function to a Web Component, and compose allows you to chain multiple mixins together. withSolid is the core mixin that enables Solid logic within the component lifecycle.

    import { register, compose } from 'component-register';
    import { withSolid } from 'solid-element';
    
    // Compose register and withSolid to create a custom element
    compose(
      register('my-component'),
      withSolid
    )((props, options) => {
      // ... Solid code
    })
  8. Handling Events and Render Props in `html`

    main

    When passing events or render props (like those used in the <For> component) to components via html, you must provide an explicit function that accepts arguments.

    Solid's html implementation automatically wraps functions passed to component props that have no arguments in getters. To prevent this behavior and ensure your event handler receives the event object (or other arguments), pass the function directly or ensure it is not being treated as a zero-argument getter.

    Correct usage:

    html`<${Button} onClick=${(e) => console.log("Hi")} />`;

    Incorrect usage (may be wrapped in a getter):

    html`<${Button} onClick=${() => console.log("Hi")} />`;
    html`<${Button} onClick=${(e) => console.log("Hi")} />`
  9. Use Solid Tagged Template Literals via `html`

    main

    The solid-js/html submodule provides an html tagged template literal method. This allows you to use Solid in environments without a compilation step (non-JSX environments) as a replacement for JSX.

    Key syntax rules:

    • Use ${} to escape into JavaScript expressions.
    • Close components using the <//> syntax.
    • Components are instantiated using <${ComponentName} ... />.
    • Attributes can be spread using ...${props}.
    • Multiple top-level elements are supported without needing a Fragment component.
    import { render } from "solid-js/web";
    import html from "solid-js/html";
    import { createSignal } from "solid-js";
    
    function Button(props) {
      return html`<button class="btn-primary" ...${props} />`;
    }
    
    function Counter() {
      const [count, setCount] = createSignal(0);
      const increment = (e) => setCount((c) => c + 1);
    
      return html`<${Button} type="button" onClick=${increment}>${count}<//>`;
    }
    
    render(Counter, document.getElementById("app"));
  10. Use Solid Web entry point methods for rendering

    main

    The solid-js/web submodule provides the primary entry point methods for rendering Solid applications in both browser and server environments. Depending on your target environment and rendering strategy, you should use one of the following methods:

    Browser Rendering

    • render: Used for standard client-side rendering (CSR) to mount a Solid application into a DOM element.
    • hydrate: Used for client-side hydration when the initial HTML was pre-rendered on the server (SSR).

    Server-Side Rendering (SSR)

    • renderToString: Synchronously renders the application to a string.
    • renderToStringAsync: Asynchronously renders the application to a string (useful for handling async components/resources).
    • pipeToNodeWritable: Pipes the rendered output to a Node.js Writable stream.
    • pipeToWritable: Pipes the rendered output to a generic Writable stream.
  11. Review SolidJS performance benchmarks

    main

    To understand the performance characteristics of SolidJS, you can review several benchmark implementations:

    • JS Framework Benchmark: The industry standard for comparing framework performance.
    • Sierpinski's Triangle Demo: A Solid implementation of the React Fiber demo to compare reconciliation/rendering approaches.
    • WebComponent Todos: Demonstrates performance and usage of solid-element for Web Components.
    • UIBench Benchmark: Tests a variety of common UI scenarios.
    • DBMon Benchmark: Tests the ability of libraries to render unoptimized data.

Svelte Documentation

repository·main·Indexed Apr 15, 2026

https://github.com/sveltejs/svelte

Official documentation for Svelte, a compiler-based framework that transforms declarative components into efficient JavaScript without a virtual DOM. Covers core concepts including Runes ($state, $derived, $effect), dependency tracking, push-pull reactivity, and template syntax features like snippets. Includes guides for setup with Vite, editor tooling, and TypeScript integration.

Tokens
40.5K
Snippets
125
Records
195
Agent score
100%

What's inside svelte

  1. What is Svelte?

    main
    Svelte is a compiler-based framework for building web applications. Unlike traditional frameworks that perform reconciliation in the browser, Svelte converts declarative components into highly efficient JavaScript at build time. This resulting code performs surgical updates to the DOM, minimizing runtime overhead.
  2. Create a new SvelteKit application

    main

    The recommended way to start a new project is using SvelteKit, the official application framework powered by Vite. Run the following commands to scaffold, install dependencies, and start the development server:

    npx sv create myapp
    cd myapp
    npm install
    npm run dev

    You can start using SvelteKit even if you are not familiar with Svelte yet. You can ignore advanced SvelteKit features initially and explore them later.

    Sources: documentation/docs/01-introduction/02-getting-started.md

  3. Minimize use of `$effect`

    main

    $effect is an escape hatch and should be avoided for standard state synchronization.

    • Avoid updating state inside an effect.
    • For external libraries (e.g., D3): Use {@attach ...}.
    • For user interaction: Use event handlers or function bindings.
    • For debugging: Use $inspect.
    • For observing external systems: Use createSubscriber.
    • Note: Effects do not run on the server; do not wrap them in if (browser) checks.
  4. Reactivity of `$derived` values and destructuring

    main

    Object/Array Reactivity

    Unlike $state, which creates deeply reactive proxies, $derived values are returned as-is. However, if the derived value is an object or array, mutating its properties (or using bind:) will affect the underlying source state if that source is deeply reactive.

    Reactive Destructuring

    When you destructure a $derived declaration, the resulting individual variables remain reactive.

    // This:
    let { a, b, c } = $derived(stuff());
    
    // Is equivalent to:
    let _stuff = $derived(stuff());
    let a = $derived(_stuff.a);
    let b = $derived(_stuff.b);
    let c = $derived(_stuff.c);
  5. When to use stores vs runes

    main

    With the introduction of Svelte 5 runes, the need for stores has diminished for many common use cases:

    • Extracting logic: Use runes in .svelte.js or .svelte.ts files to leverage universal reactivity outside of components.
    • Shared state: Create a $state object in a JavaScript/TypeScript file and export it.

    When to still use stores:

    • When handling complex asynchronous data streams.
    • When you require manual control over updating values or listening to changes.
    • When integrating with libraries like RxJS.
    /// file: state.svelte.js
    export const userState = $state({
    	name: 'name',
    	/* ... */
    });
    <!--- file: App.svelte --->
    <script>
    	import { userState } from './state.svelte.js';
    </script>
    
    <p>User name: {userState.name}</p>
    <button onclick={() => {
    	userState.name = 'new name';
    }}>
    	change name
    </button>
  6. Use `$state` for reactive variables

    main

    Use the $state rune only for variables that need to be reactive (i.e., they trigger updates in $effect, $derived, or templates). For large objects or arrays that are reassigned rather than mutated (like API responses), use $state.raw to avoid the performance overhead of deep reactivity proxies.

    // Deeply reactive (mutations trigger updates)
    let user = $state({ name: 'John' });
    user.name = 'Jane';
    
    // Shallowly reactive (only reassignment triggers updates)
    let apiData = $state.raw({ items: [] });
    apiData = { items: [1, 2, 3] };
  7. Store reactive state in context

    main

    You can pass reactive $state objects through context to allow multiple components to share and react to the same state.

    Important: When using context with state, avoid reassigning the context variable itself (e.g., counter = { count: 0 }), as this 'breaks the link' to the original reactive object. Instead, mutate the properties of the existing state object (e.g., counter.count = 0). Svelte will issue a warning if you attempt to reassign the object instead of mutating it.

    import { createContext } from 'svelte';
    
    interface Counter {
    	count: number;
    }
    
    export const [getCounter, setCounter] = createContext<Counter>();
    <!--- App.svelte --->
    <script>
    	import { setCounter } from './context.ts';
    	import Child from './Child.svelte';
    
    	let counter = $state({
    		count: 0
    	});
    
    	setCounter(counter);
    </script>
    
    <button onclick={() => counter.count += 1}>increment</button>
    <Child />
    <!--- Child.svelte --->
    <script>
    	import { getCounter } from './context.ts';
    	const counter = getCounter();
    </script>
    
    <p>{counter.count}</p>
  8. Making classes reactive in Svelte 5

    main

    In Svelte 5, reactivity is determined at runtime. Simply instantiating a class does not make its properties reactive. To make a class reactive, you must define its properties using the $state rune inside the class definition.

    Incorrect (Svelte 4 style):

    <script>
      let foo = new Foo();
    </script>
    <button on:click={() => (foo.value = 1)}>{foo.value}</button>

    Correct (Svelte 5 style):

    class Foo {
      value = $state(0);
    }

    Note: Wrapping a class instance in $state(new Foo()) does not make the class properties reactive; only vanilla objects and arrays are made deeply reactive by $state.

  9. How Svelte 5 lifecycle works compared to Svelte 4

    main

    In Svelte 5, the component lifecycle is simplified to just two parts: creation and destruction.

    In Svelte 4, hooks like beforeUpdate and afterUpdate ran whenever a component updated. In Svelte 5, the smallest unit of change is the render effect set up during initialization. Consequently, there are no component-wide update hooks. Instead, you use runes to react to specific state changes:

    • Instead of beforeUpdate: Use $effect.pre to run code before the DOM is updated. To ensure it only runs when specific state changes, explicitly reference that state inside the effect.
    • Instead of afterUpdate: Use $effect to run code after the DOM has been updated.

    This approach provides more granular control and prevents unnecessary code execution when unrelated state (like a theme toggle) changes.